/*
 ķ
   Program..: _DCSCOPE.PRG                                     
   Author...: Roger J. Donnay                                  
   Date.....: Sep 22, 2001                                     
   Notes....: Scoping System for XBase++                       
 Ľ
*/

#include 'dcdialog.ch'
#include 'dcscope.ch'
#include 'inkey.ch'
#include 'set.ch'
#include 'dmlb.ch'
#include 'dbfdbe.ch'
#INCLUDE "dcads.CH"
#INCLUDE "dccargo.CH"

#ifndef SCOPE_TOP
  #define SCOPE_TOP    0x01
  #define SCOPE_BOTTOM 0x02
  #define SCOPE_BOTH   0xFF
#endif

#ifndef _SET_SMARTFILTER
  #define  _SET_OPTIMIZE     48  // SETs for expression optimizer
  #define  _SET_RUSHMORE     49  // SETs for rushmore optimizer
  #define  _SET_SMARTFILTER  50  // SETs for smart filtering
#endif

#ifndef ADS_TOP
  #define ADS_TOP     1
  #define ADS_BOTTOM  2
#endif

EXTERNAL AX_SetScope

STATIC slKeyEnable := .t.

* ---------------

FUNCTION DC_SetScope( nWhich, xValue )

LOCAL aScope, xOldValue


if empty( alias() ) .or. pcount() = 0 .or. IndexOrd() = 0
   return nil
endif

IF !DC_ScopeExpress()
  IF nWhich == 0
    nWhich := SCOPE_TOP
  ELSEIF nWhich == 1
    nWhich := SCOPE_BOTTOM
  ENDIF
  xOldValue := dbScope(nWhich)
  IF PCount() >= 2
    IF xValue == NIL
      dbClearScope(nWhich)
    ELSE
      dbSetScope(nWhich,xValue)
    ENDIF
  ENDIF
  return xOldValue
ENDIF

nWhich := iif( valtype( nWhich ) = 'N', nWhich, 0 )
if nWhich > 1 .or. nWhich < 0
   return nil
endif

aScope := DC_DbCargo()

if pcount() = 1
   if _SetRdd() == 'ADSDBE' .AND. DC_ScopeAds()
     IF nWhich = 0
       nWhich := ADS_TOP
     ELSEIF nWhich = 1
       nWhich := ADS_BOTTOM
     ENDIF
     xValue := AX_SetScope(nWhich)
   else
     xValue := aScope[ DCCARGO_ORDER_ARRAY, IndexOrd(), nWhich + 1 ]
   endif
   IF Valtype(xValue) = 'C' .AND. Len(xValue) = 0
     RETURN nil
   ELSE
     RETURN xValue
   ENDIF
else
   IF _SetRdd() == 'ADSDBE' .AND. DC_ScopeAds()
     IF nWhich = 0
       nWhich := ADS_TOP
     ELSEIF nWhich = 1
       nWhich := ADS_BOTTOM
     ENDIF
     if valtype( xValue ) = 'U'
       AX_ClrScope(nWhich)
     else
       AX_SetScope(nWhich,xValue)
     endif
   ELSE
     aScope[ DCCARGO_ORDER_ARRAY, IndexOrd(), nWhich + 1 ]  := xValue
     aScope[ DCCARGO_ORDER_ARRAY, IndexOrd(), DCCARGO_ORDER_GOODCOUNT ] := .f.
     aScope[ DCCARGO_ORDER_ARRAY, IndexOrd(), DCCARGO_ORDER_GOODPOS ] := .f.
     dbCargo(aScope)
   ENDIF
endif

return xValue

* ---------------

FUNCTION DC_SetScopeArray( aScopeArray )

LOCAL aScope, xValue

if empty( alias() ) .OR. _IndexOrd() = 0
   return nil
endif

aScope := DC_DbCargo()

if pcount() = 0
  xValue := aScope[ DCCARGO_ORDER_ARRAY, _IndexOrd(), DCCARGO_ORDER_RECARRAY ]
else
  aScope[ DCCARGO_ORDER_ARRAY, _IndexOrd(), DCCARGO_ORDER_RECARRAY ] := aScopeArray
  aScope[ DCCARGO_ORDER_ARRAY, _IndexOrd(), DCCARGO_ORDER_RECPOINTER ] := 1
  dbCargo(aScope)
endif

return xValue

* ---------------

FUNCTION DC_SetScopeArrayPointer( nPointer )

LOCAL aScope, xValue

aScope := DC_DbCargo()

if pcount() = 0
  xValue := aScope[ DCCARGO_ORDER_ARRAY, _IndexOrd(), DCCARGO_ORDER_RECPOINTER ]
else
  aScope[ DCCARGO_ORDER_ARRAY, _IndexOrd(), DCCARGO_ORDER_RECPOINTER ] := nPointer
  dbCargo(aScope)
endif

return xValue

* ---------------

FUNCTION DC_ClrScope()

IF !DC_ScopeExpress()
  dbClearScope(1)
  dbClearScope(2)
  RETURN nil
ENDIF

IF _SetRdd() == 'ADSDBE' .AND. IsFunction('AX_ClrScope') .AND. DC_ScopeAds()
   AX_ClrScope( 0 )
   AX_ClrScope( 1 )
else
   DC_SetScope( 0, nil )
   DC_SetScope( 1, nil )
endif

return nil

* --------------

FUNCTION DC_SetRelation( cAlias, bKey, cKey, lSetScope )

LOCAL nSaveArea := Select(), lOk, bErrorBlock, xReturn

DEFAULT lSetScope := .f.

IF Valtype( cAlias ) # 'C' .OR. Valtype( bKey ) # 'B' // .or. valtype( cKey ) # 'C'
   DC_WinAlert( "Invalid Parameters passed to DC_SetRelation()" )
   RETURN nil
ENDIF
IF Alias() == Upper( cAlias )
   DC_WinAlert('Invalid Relation' + Chr(13) + ;
               'Cannot set a relation to self' )
   RETURN nil
ENDIF
dbSelectArea(cAlias)
IF Alias() # Upper(cAlias)
   DC_WinAlert( 'Invalid Relation', 'Alias ' + cAlias + ' does not exist' )
   RETURN nil
ENDIF
BEGIN SEQUENCE
SELE( nSaveArea )
bErrorBlock := Errorblock( { || _scopeerr() } )
lOk         := .f.
Eval( bKey )
lOk := .t.
END SEQUENCE
Errorblock( bErrorBlock )
IF !lOk
   DC_WinAlert( 'Invalid Relation: ' + cKey )
   RETURN nil
ENDIF
IF lSetScope
   IF '"' $ cKey
      cKey := "DC_SetRelScope('" + cAlias + "','" + cKey + "')"
   ELSE
      cKey := 'DC_SetRelScope("' + cAlias + '","' + cKey + '")'
   ENDIF
   bKey    := &( '{||' + cKey + '}' )
   xReturn := dbSetRelation( cAlias, bKey, cKey )
ELSE
   xReturn := dbSetRelation( cAlias, bKey, cKey )
ENDIF

RETURN xReturn

* ------------

FUNCTION DC_SetRelScope( cAlias, cKey )

local nSaveArea := select()
local xValue

xValue := &cKey
sele( cAlias )
DC_SetScope( 0, xValue )
DC_SetScope( 1, xValue )
sele( nSaveArea )

RETURN xValue

* -------------

STATIC PROCEDURE _scopeerr

BREAK

RETURN

* -------------

STATIC FUNCTION _SetRdd( cRdd )

local cRddName

if valtype( cRdd ) = 'C'
   cRddName := DBESetDefault( cRdd )
elseif !empty( alias() )
   cRddName := DbInfo( DBO_DBENAME )
else
   cRddName := DbeSetDefault()
endif

return cRddName

* ----------------------

FUNCTION DC_dbGoTop( xDataSource )

LOCAL aScope, aScopeArray := DC_SetScopeArray()

IF Valtype(aScopeArray) = 'A' .AND. !Empty(aScopeArray)
  aScope := DC_DbCargo()
  aScope[DCCARGO_ORDER_ARRAY, _IndexOrd(),DCCARGO_ORDER_BOF] := .f.
  aScope[DCCARGO_ORDER_ARRAY, _IndexOrd(),DCCARGO_ORDER_EOF] := .f.
  dbCargo(aScope)
  IF Valtype(aScopeArray[1]) = 'A'
    _dbGoTo(aScopeArray[1,1])
  ELSE
    _dbGoTo(aScopeArray[1])
  ENDIF
  DC_SetScopeArrayPointer(1)
  RETURN nil
ENDIF

IF !DC_ScopeExpress() .OR. !Empty(xDataSource)
  IF Empty(xDataSource)
    _dbGoTop()
  ELSEIF Valtype(xDataSource) == 'C' // It's an alias
    (xDataSource)->(_dbGoTop())
  ELSEIF Valtype(xDataSource) == 'N' // It's an ADS SQL cursor
     AdsGoToTop(xDataSource)
  ELSEIF Valtype(xDataSource) == 'O' // It's an SQLexpress cursor
     xDataSource:goTop()
  ENDIF
  RETURN nil
ENDIF

if Left(DbInfo(DBO_FILENAME),8)=='<CURSOR>'
  dbGoTop()
elseif _SetRdd() == 'ADSDBE' .AND. DC_ScopeAds()
   _dbgotop()
else
   DC_dbRecTop()
endif

return nil

* --------------

FUNCTION DC_dbGoBottom( xDataSource )

LOCAL aScopeArray := DC_SetScopeArray(), nPointer, aScope

IF Valtype(aScopeArray) = 'A' .AND. !Empty(aScopeArray) .AND. Empty(xDataSource)
  aScope := DC_DbCargo()
  aScope[DCCARGO_ORDER_ARRAY, _IndexOrd(),DCCARGO_ORDER_BOF] := .f.
  aScope[DCCARGO_ORDER_ARRAY, _IndexOrd(),DCCARGO_ORDER_EOF] := .f.
  dbCargo(aScope)
  nPointer := Len(aScopeArray)
  IF Valtype(aScopeArray[nPointer]) = 'A'
    _dbGoTo(aScopeArray[nPointer,1])
  ELSE
    _dbGoTo(aScopeArray[nPointer])
  ENDIF
  DC_SetScopeArrayPointer(nPointer)
  RETURN nil
ENDIF

IF !DC_ScopeExpress() .OR. !Empty(xDataSource)
  IF Empty(xDataSource)
    _dbGoBottom()
  ELSEIF Valtype(xDataSource) == 'C' // It's an alias
    (xDataSource)->(_dbGoBottom())
  ELSEIF Valtype(xDataSource) == 'N' // It's an ADS SQL cursor
     AdsGoToBottom(xDataSource)
  ELSEIF Valtype(xDataSource) == 'O' // It's an SQLexpress cursor
     xDataSource:goBottom()
  ENDIF
  RETURN nil
ENDIF

if Left(DbInfo(DBO_FILENAME),8)=='<CURSOR>'
  dbGoBottom()
elseif _SetRdd() == 'ADSDBE' .AND. DC_ScopeAds()
   _dbgobottom()
else
   DC_dbRecBottom()
endif

RETURN nil

* ----------------

FUNCTION DC_dbSkipper( nRecords, lPercent, lDescending, lUnique )
* pass extra flag to DC_dbSkip...
RETURN DC_dbSkip( nRecords, lPercent, .T., lDescending,, lUnique )

* ----------------

FUNCTION DC_dbSkip( nRecords, lPercent, lSkipper, lDescending, xDataSource, lUnique )

LOCAL i, xScopeTop, xScopeBot, nRecCount := 0, aScope, ;
      lExact := Set(_SET_EXACT,.f.), aScopeArray, nPointer

LOCAL lHasScopeTop, lHasScopeBot, nDidSkip

IF Valtype(lPercent) $ 'NOC'
  xDataSource := lPercent
ENDIF

IF Valtype(nRecords)=="N" .AND. nRecords == 0
  Set(_SET_EXACT,lExact)
  RETURN 0
ENDIF

IF Valtype(xDataSource) $ 'NOC'
  IF Valtype(xDataSource) == 'C' // It's an alias
    RETURN (xDataSource)->(_dbSkip(nRecords))
  ELSEIF Valtype(xDataSource) == 'N' // It's an ADS SQL cursor
    RETURN AdsSkip(xDataSource,nRecords)
  ELSEIF Valtype(xDataSource) == 'O' // It's an SQLexpress cursor
    RETURN xDataSource:skip(nRecords)
  ENDIF
ENDIF

DEFAULT nRecords := 1, ;
        lPercent := .f., ;
        lSkipper := .f., ;
        lDescending := .f., ;
        lUnique := .f.

aScopeArray := DC_SetScopeArray()

IF Valtype(aScopeArray) = 'A' .AND. !Empty(aScopeArray)
  aScope := DC_DbCargo()
  aScope[DCCARGO_ORDER_ARRAY, _IndexOrd(),DCCARGO_ORDER_BOF] := .F.
  dbCargo(aScope)
  nPointer := DC_SetScopeArrayPointer()
  IF lDescending
    nRecords := nRecords * -1
  ENDIF
  IF nPointer = 0 .AND. nRecords > 0 // at EOF
    Set(_SET_EXACT,lExact)
    RETURN 0
  ELSEIF nPointer = 0 .AND. nRecords < 0
    nPointer := Len(aScopeArray) + 1
  ENDIF
  IF nRecords > 0 .AND. Len(aScopeArray) > 0
    IF nPointer + nRecords > Len(aScopeArray)
      nDidSkip := Len(aScopeArray)-nPointer
      IF lSkipper
        nPointer := Len(aScopeArray)
      ELSE
        nPointer := 0
      ENDIF
    ELSE
      nPointer += nRecords
      nDidSkip := nRecords
    ENDIF
  ELSEIF nRecords < 0 .AND. Len(aScopeArray) > 0
    IF nPointer + nRecords < 1
      nDidSkip := nPointer * -1 + 1
      nPointer := 1
      aScope[DCCARGO_ORDER_ARRAY, _IndexOrd(),DCCARGO_ORDER_BOF] := .t.
      dbCargo(aScope)
    ELSE
      nPointer += nRecords
      nDidSkip := nRecords
    ENDIF
  ELSE
    nDidSkip := 0
  ENDIF
  IF nDidSkip = 0 .AND. !lSkipper .AND. nRecords >= 0
    nPointer := 0 // eof
  ENDIF
  IF nPointer > 0 .AND. nPointer <= Len(aScopeArray)
    IF Valtype(aScopeArray[nPointer]) = 'A'
      _dbGoTo(aScopeArray[nPointer,1])
    ELSE
      _dbGoTo(aScopeArray[nPointer])
    ENDIF
  ELSE
    _dbGoTo(0)
  ENDIF
  DC_SetScopeArrayPointer(nPointer)
  Set(_SET_EXACT,lExact)
  RETURN nDidSkip
ENDIF

xScopeTop := DC_SetScope(0)
lHasScopeTop := (Valtype(xScopeTop) # 'U')

xScopeBot := DC_SetScope(1)
lHasScopeBot := (Valtype(xScopeBot) # 'U')

IF !DC_ScopeExpress() .OR. !lHasScopetop .OR. !lHasScopeBot .OR. Left(DbInfo(DBO_FILENAME),8)=='<CURSOR>'

  IF lSkipper
    IF !lDescending
      nDidSkip := dbSkipper(nRecords,lUnique)
    ELSE
      nDidSkip := -1*dbSkipper(-1*nRecords,lUnique)
    ENDIF
  ELSE
    IF lUnique
      IF !lDescending
        nDidSkip := dbSkipUnique( nRecords )
      ELSE
        nDidSkip = dbSkipUnique( -1 * nRecords)
      ENDIF
    ELSE
       IF !lDescending
        nDidSkip := dbSkip( nRecords )
      ELSE
        nDidSkip = dbSkip( -1 * nRecords)
      ENDIF
    ENDIF
  ENDIF
  /*
  IF RecNo() == nSaveRec
    nDidSkip := 0
  ENDIF
  */
  Set(_SET_EXACT,lExact)

  RETURN nDidSkip

ENDIF

IF lDescending
  nRecords := -1 * nRecords
ENDIF

IF nRecords < 0

  * perform skip record by record, and make tests per loop
  FOR i := nRecords to - 1
     * bof already, if so stop
     IF DC_Bof()
       IF lSkipper
         DC_DbGotop()
       ENDIF
       EXIT
     ELSEIF Eof()
       DC_DbGoBottom()
       IF Eof()
         EXIT
       ENDIF
       LOOP
     ENDIF
     * first attempt to make 1 skip
     _DbSkip( -1 )
     * -- Oops, bof(), or past scope top, --
     *    stay at scope top record, and set DC_Bof if necessary.
     IF Bof() .OR. (lHasScopeTop .AND. _ScopeKey( xScopeTop ) < xScopeTop)
       IF ! Bof() .or. lSkipper
         DC_DbGotop()
       ENDIF
       IF !lSkipper
         DC_Bof( .T. )
       ENDIF
       EXIT
     ENDIF
     * done with 1 skip, loop back for more
     nRecCount--
     DC_Eof( .f. )
     DC_Bof( .f. )
   NEXT

ELSEIF nRecords > 0

  * perform skip record by record, and make tests per loop
  FOR i := 1 to nRecords
    * eof already, if so stop
    IF DC_Eof()
      IF lSkipper
        DC_DbGobottom()
      ENDIF
      EXIT
    ENDIF

    * first attempt to make 1 skip
    _DbSkip( 1 )

    * -- Oops, eof(), or past scope bottom, --
    *    if doing skipper, go to scopebottom and don't force DC_Eof()
    *    else go to phantom record, and set DC_Eof.
    IF EOF() .or. (lHasScopeBot .AND. _ScopeKey( xScopeBot ) > xScopeBot)
      IF lSkipper
        DC_DbGobottom()     // reset eof(), (unless no rec. in file)
                            // and stay at last record.
      ENDIF
      IF !lSkipper
        nRecCount++
        IF ! EOF()
          _DbGoto( RecCount() + 1 )   // goto phantom rec.
        ENDIF
        DC_Eof( .T. )
      ENDIF
      EXIT
    ENDIF

    * done with 1 skip, loop back for more
    nRecCount++
    DC_Eof( .f. )
    DC_Bof( .f. )
  NEXT

ENDIF

IF lDescending
  nRecCount *= -1
ENDIF

Set(_SET_EXACT,lExact)

RETURN nRecCount


* --------------

FUNCTION DC_Eof( lSetEof, xDataSource )

LOCAL aScope, lEof, lExact

IF !DC_ScopeExpress()
  RETURN Eof()
ENDIF
IF _SetRdd() == 'ADSDBE' .AND. DC_ScopeAds()
  return eof()
ELSEIF empty( alias() ) .or. Valtype( DC_SetScope( 1 ) ) == 'U'
   return eof()
ENDIF

lExact := Set(_SET_EXACT,.f.)
aScope := DC_DbCargo()

lEof := aScope[ DCCARGO_ORDER_ARRAY, IndexOrd(), DCCARGO_ORDER_EOF ]
lEof := iif( valtype( lEof ) = 'L', lEof, .f. )
if valtype( lSetEof ) = 'L'
   aScope[ DCCARGO_ORDER_ARRAY, _IndexOrd(), DCCARGO_ORDER_EOF ] := lSetEof
endif

dbCargo(aScope)
Set(_SET_EXACT,lExact)

return lEof

* -------------------

FUNCTION DC_Bof( lSetBof, xDataSource )

local lBof, aScope, lExact

IF Valtype(DC_SetScopeArray())='A'
  aScope := DC_DbCargo()
  RETURN aScope[ DCCARGO_ORDER_ARRAY, _IndexOrd(), DCCARGO_ORDER_BOF ]
ENDIF

IF !DC_ScopeExpress()
  RETURN Bof()
ENDIF

if _SetRdd() == 'ADSDBE' .AND. DC_ScopeAds()
   return bof()
elseif empty( alias() ) .or. Valtype( DC_SetScope( 0 ) ) == 'U'
   return bof()
endif

lExact := Set(_SET_EXACT,.f.)
aScope := DC_DbCargo()

lBof := aScope[ DCCARGO_ORDER_ARRAY, IndexOrd(), DCCARGO_ORDER_BOF ]
lBof := iif( valtype( lBof ) = 'L', lBof, .f. )
if valtype( lSetBof ) = 'L'
   aScope[ DCCARGO_ORDER_ARRAY, IndexOrd(), DCCARGO_ORDER_BOF ] := lSetBof
endif

dbCargo(aScope)

Set(_SET_EXACT,lExact)

return lBof

* -----------------

FUNCTION DC_dbRecTop()

local xScopeTop
local xScopeBot
local nTopRec
local lSoftSeek := set( _SET_SOFTSEEK )
local nSaveRec := RecNo()
LOCAL nRecNo, lExact

IF !DC_ScopeExpress()
  _dbGoTop()
  nRecNo := RecNo()
  _dbGoTo(nSaveRec)
  RETURN nRecNo
ENDIF

lExact := Set(_SET_EXACT,.f.)
xScopeTop := DC_SetScope( 0 )
xScopeBot := DC_SetScope( 1 )

* Use special scope-aware seek, or just DbGoBottom() ...
  IF Valtype( xScopeTop ) # 'U' .AND. !Empty( IndexKey( 0 ) ) .and. ;
             Valtype( xScopeTop ) = Valtype( &( IndexKey( 0 ) ) )

     *--- new code: not handling _IsDescend() yet ---
     DC_Bof( .f. )
     DC_Eof( .f. )
     SET SOFTSEEK ON
     SEEK xScopeTop
     Set( _SET_SOFTSEEK, lSoftSeek )
     nTopRec := RecNo()
     * -- Oops, eof(), or past scope bottom --
     IF EOF() .OR. (Valtype(xScopeBot)#'U' .AND. _ScopeKey( xScopeBot ) > xScopeBot)
        nTopRec := RecCount() + 1
        _DbGoto( nTopRec )
        DC_Bof( .T. )
        DC_Eof( .T. )
     ENDIF

  ELSE

     _dbGoTop()
     DC_Bof( bof() )
     DC_Eof( eof() )
     nTopRec := RecNo()

  ENDIF

* GO nSaveRec

Set(_SET_EXACT,lExact)

return nTopRec

/* ------------------------ */

FUNCTION DC_dbRecBottom()

local xScopeTop
local xScopeBot
local nBotRec
local cLastChar
local nSaveRec := RecNo()
LOCAL nRecNo
LOCAL lExact

IF !DC_ScopeExpress()
  _dbGoBottom()
  nRecNo := RecNo()
  _dbGoTo(nSaveRec)
  RETURN nRecNo
ENDIF

lExact := Set(_SET_EXACT,.f.)
xScopeBot := DC_SetScope( 1 )
xScopeTop := DC_SetScope( 0 )

* nSaveRec := recno()

* Use special scope-aware seek, or just DbGoBottom() ...
  if Valtype(xScopeBot) # 'U' .and. !empty( indexkey( 0 ) ) .and. ;
              valtype( xScopeBot ) = valtype( &( indexkey( 0 ) ) )

      *--- new code: not handling _IsDescend() yet ---
      *    only handling 'C' type indexkey for now ...
      DC_Bof( .f. )
      DC_Eof( .f. )    // init. default

      // warning: cLastChar possibly affected by codepage
      IF Valtype(xScopeBot) = 'C'
        cLastChar := DC_LastChar()
        _dbseek( xScopeBot + cLastChar, .t. )
      ELSEIF Valtype(xScopeBot) $ 'ND'
        _dbSeek( xScopeBot + 1, .t. )
      ENDIF

      * get past last record matching xScopeBot
      *    note: xScopeBot already tested to be non-empty
      *    now, _ScopeKey( xScopeBot )  can only be >= xScopeBot

      DO WHILE ! EOF() .AND. _ScopeKey( xScopeBot ) == xScopeBot
         * skip past the current group
         * - only required if orig. cLastChar = chr(255)
         _DbSkip( 1 )
      ENDDO

      * then back up 1 record
      _DbSkip( - 1 )
      nBotRec := RecNo()

      * -- Oops, bof(), or earlier than scope top --
      IF BOF() .OR. (Valtype(xScopeTop)#'U' .AND. _ScopeKey( xScopeTop ) < xScopeTop)
         nBotRec := RecCount() + 1
         _DbGoto( nBotRec )
         DC_Bof( .T. )
         DC_Eof( .T. )
      ENDIF
  else
      _dbgobottom()
      DC_Bof( bof() )
      DC_Eof( eof() )
      nBotRec := recno()
  endif

* go nSaveRec

Set(_SET_EXACT,lExact)

return nBotRec

* -----------------

FUNCTION DC_DbSeek(cKey, lSoftseek, cIndexTag, lSeekLast, xDataSource )

LOCAL lFound := .f.
LOCAL xScopeTop, xScopeBot
LOCAL lExact, xValue, i, xCargo
LOCAL aScopeArray := DC_SetScopeArray()
LOCAL cDataType := Valtype(xDataSource)

IF cDataType == 'O' // It's an SQLexpress cursor

  lFound := xDataSource:seek( cKey, lSoftSeek )
  IF DC_IsSQLCargo( xDataSource, @xCargo )
    xCargo[DCSQL_CARGO_FOUND] := lFound
  ENDIF
  RETURN lFound

ELSEIF cDataType == 'N' // It's an ADS SQL cursor
  // AdsSeek( nIndex, @cKey, cLength, nDataType, nSeekType, @lFound )
  RETURN .F.

ELSEIF DC_ScopeAds() .AND. _SetRdd()='ADSDBE'
//roger
  RETURN dbSeek( cKey, lSoftSeek, cIndexTag, lSeekLast )

ENDIF

IF !Empty(aScopeArray)
  FOR i := 1 TO Len(aScopeArray)
    IF Valtype(aScopeArray[i]) = 'A'
      GOTO aScopeArray[i,1]
    ELSE
      GOTO aScopeArray[i]
    ENDIF
    IF &(IndexKey(0)) = cKey
      DC_SetScopeArrayPointer(i)
      RETURN .T.
    ENDIF
  NEXT
  GO BOTTOM
  SKIP
  RETURN .F.
ELSEIF !DC_ScopeExpress()
  lExact := Set(_SET_EXACT,.f.)
  xValue := _DbSeek( cKey, lSoftSeek, cIndexTag, lSeekLast )
  Set(_SET_EXACT,lExact)
  RETURN xValue
ENDIF

lExact := Set(_SET_EXACT,.f.)
DEFAULT lSoftseek := Set(_SET_SOFTSEEK)

* perform the Xbase seek first
  lFound := _DbSeek(cKey, lSoftseek, cIndexTag, lSeekLast )

* set DC_Bof, DC_Eof
  DC_Eof(eof())
  DC_Bof(bof())

* Roger: return only after setting DC_Eof(), DC_Bof()
* IF !lFound   // Roger: Xbase is changed, can no longer trust this flag.
  IF eof()
    Set(_SET_EXACT,lExact)
    RETURN .f. // lFound : Note: I think that suits most cases.
  ENDIF

  xScopeTop := DC_SetScope( 0 )
  xScopeBot := DC_SetScope( 1 )

  IF Valtype(xScopeTop)#'U' .AND. _ScopeKey( xScopeTop ) < xScopeTop
    * IF Set(_SET_SOFTSEEK)  //  possible bug??
    IF Set(_SET_SOFTSEEK) .OR. lSoftSeek
      DC_DbGoTop()
    ELSE
      _dbGoBottom()
      _dbSkip()
      DC_Eof(.t.)       // Roger: should set this ??
    ENDIF
  ELSEIF Valtype(xScopeBot)#'U' .AND. _ScopeKey( xScopeBot ) > xScopeBot
    _dbGoBottom()
    _dbSkip()
    DC_Eof(.t.)         // Roger: should set this ??
  ENDIF

  lFound := ! DC_Eof()

Set(_SET_EXACT,lExact)

RETURN lFound

* --------------------

FUNCTION DC_Found( xDataSource )

LOCAL cDataType := Valtype(xDataSource), lFound := .F., xCargo

IF xDataSource == NIL
  lFound := Found()
ELSEIF cDataType == 'C' // It's an alias
  lFound := (xDataSource)->(Found())
ELSEIF cDataType == 'O' // It's an SQLexpress cursor
  IF DC_IsSQLCargo( xDataSource, @xCargo )
    lFound := xCargo[DCSQL_CARGO_FOUND]
  ENDIF
ELSEIF cDataType == 'N' // It's an ADS SQL cursor
  AdsIsFound( xDataSource, @lFound )
ENDIF

RETURN lFound

* --------------------

STATIC FUNCTION _ScopeKey( xScope )

LOCAL xValue := &( IndexKey( 0 ) )

IF Valtype( xScope ) = 'C'
   RETURN SubStr( xValue, 1, Len( xScope ) )
ENDIF

RETURN xValue

* ---------------------

STATIC FUNCTION _IsDescend( nOrder )

LOCAL nSaveOrd, lDescend := .f.

IF Empty(Alias())
   RETURN .f.
ENDIF
nSaveOrd := IndexOrd()
IF !Empty(nOrder)
  OrdSetFocus(nOrder)
ENDIF
IF IndexOrd() > 0
  lDescend := OrdIsDescend()
ENDIF
OrdSetFocus(nSaveOrd)

RETURN lDescend

/* ---------------------- */

FUNCTION DC_dbPosition ( nTimeOut, lDescending )

LOCAL nRecCount, nKeyNo, aScope, bErrorBlock, nPosition := 0, xScopeTop, xScopeBot
LOCAL lExact, aScopeArray, nPointer

IF Empty(Alias()) .OR. RecCount() = 0 .OR. Upper(_SetRdd())='PGDBE'
  RETURN 0
ENDIF

DEFAULT lDescending := .f.

aScopeArray := DC_SetScopeArray()
IF Valtype(aScopeArray) = 'A'
  IF Empty(aScopeArray)
    RETURN 0
  ENDIF
  nPointer := DC_SetScopeArrayPointer()
  IF nPointer = 1
    nPointer := 0
  ENDIF
  nPosition := (nPointer/Len(aScopeArray))*100
  IF lDescending
    RETURN 100-nPosition
  ELSE
    RETURN nPosition
  ENDIF
ENDIF

IF !DC_ScopeExpress()
  IF lDescending
    RETURN 100-dbPosition()
  ELSE
    RETURN dbPosition()
  ENDIF
ENDIF

IF IndexOrd() = 0
  bErrorBlock := ErrorBlock({||_PosError()})
  BEGIN SEQUENCE
  nPosition := dbPosition()
  END SEQUENCE
  ErrorBlock(bErrorBlock)
  RETURN nPosition
ENDIF

lExact := Set(_SET_EXACT,.f.)
aScope := DC_DbCargo()

xScopeTop := aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_TOP]
xScopeBot := aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_BOTTOM]

IF Valtype(xScopeTop) = 'C' .AND. Len(xScopeTop) = 0
  xScopeTop := nil
ENDIF

IF Valtype(xScopeBot) = 'C' .AND. Len(xScopeBot) = 0
  xScopeBot := nil
ENDIF

IF Valtype(xScopeTop) # 'U' .AND. Valtype(xScopeBot) # 'U'
  nKeyNo := DC_KeyNo( nTimeOut, @nRecCount )
  IF nKeyNo = -1 .OR. nRecCount = 0
    Set(_SET_EXACT,lExact)
    RETURN 0
  ENDIF
  nPosition := Int(100*(nKeyNo/nRecCount))
  IF lDescending
    nPosition := 100 - nPosition
  ENDIF
  Set(_SET_EXACT,lExact)
  RETURN nPosition
ELSE
  nRecCount := DC_KeyCount()
ENDIF

bErrorBlock := ErrorBlock({||_PosError()})
BEGIN SEQUENCE
nPosition := dbPosition()
END SEQUENCE
ErrorBlock(bErrorBlock)

IF lDescending
  nPosition := nRecCount - nPosition
ENDIF

Set(_SET_EXACT,lExact)

RETURN nPosition

* ---------------

STATIC PROCEDURE _PosError()

BREAK
RETURN

* ---------------------- *

FUNCTION DC_keyno ( nTimeOut, nRecCount )

LOCAL nRecNo, cRdd, nTopKeyNo, nCurrKeyNo, ;
      cIndexKey, aScope, nKeyNo, nBottomKeyNo, nTime

LOCAL nSaveRec, nBottomKey, nTopKey, aScopeArray

aScopeArray := DC_SetScopeArray()
IF Valtype(aScopeArray) = 'A'
  RETURN DC_SetScopeArrayPointer()
ENDIF

IF Upper(_SetRdd())='PGDBE'
  RETURN -1
ENDIF

   DEFAULT nTimeOut := 2
   IF !DC_ScopeExpress()
      IF Empty(Alias())
         nRecCount := 0
         RETURN 0
      ENDIF
      nSaveRec := RecNo()
      _dbGoBottom()
      IF Eof()
         nRecCount := 0
         _dbGoTo(nSaveRec)
         RETURN 0
      ENDIF
      nBottomKey := OrdKeyNo()
      _dbGoTop()
      nTopKey := OrdKeyNo()
      IF nTopKey == NIL .OR. nBottomKey == NIL  // bug in ADSDBE when index is empty
        RETURN nSaveRec
      ENDIF
      nRecCount := nBottomKey - nTopKey + 1
      _dbGoTo(nSaveRec)
      nKeyNo := OrdKeyNo()
      IF Empty(nKeyNo)
        RETURN -1
      ENDIF
      RETURN OrdKeyNo() - nTopKey + 1
   ENDIF

   IF EMPTY(ALIAS())
      nRecCount := 0
      RETURN -1
   ENDIF

   IF IndexOrd() = 0
      nRecCount := 0
      RETURN RecNo()
   ENDIF

   aScope := DC_DbCargo()
   nRecCount := 0
   cIndexKey := IndexKey(0)
   IF EMPTY(cIndexKey)
      nRecCount := RecCount()
      RETURN RecNo()
   ENDIF
   cRdd := _SetRdd()

   IF cRdd == 'ADSDBE' .AND. DC_ScopeAds()
     nRecCount := AX_KeyCount()
     nKeyNo := AX_KeyNo()
     RETURN nKeyNo
   ELSEIF cRdd == 'PGDBE'
     RETURN -1
   ENDIF

   IF slKeyEnable

      IF aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_ERROR]
        RETURN -1
      ELSEIF Valtype(aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_TOP])='U' .AND. ;
           Valtype(aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_BOTTOM])='U'
        nTime := Seconds()
        nKeyNo := OrdKeyNo()
        IF Seconds() - nTime > nTimeOut
          aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_ERROR] := .t.
          RETURN -1
        ELSEIF Valtype(nKeyNo) # 'N'
           RETURN RecNo()
        ENDIF
        RETURN nKeyNo
      ENDIF

      nRecNo := RecNo()
      IF !(aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_GOODCOUNT]) .OR. ;
            !(aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_RECORD] == nRecNo)
         IF !(aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_GOODPOS])
            DC_dbGoBottom()
            nBottomKeyNo := OrdKeyNo()
            DC_dbGoTop()
            nTopKeyNo := OrdKeyNo()
            _dbGoTo(nRecNo)
            nRecCount := nBottomKeyNo - nTopKeyNo + 1
            aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_KEYCOUNT] := nRecCount
            aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_TOPKEYNO] := nTopKeyNo
            aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_GOODPOS] := .t.
         ELSE
            nTopKeyNo := aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_TOPKEYNO]
         ENDIF
         nCurrKeyNo := OrdKeyNo()
         IF Valtype(nCurrKeyNo) # 'N' .OR. Valtype(nTopKeyNo) # 'N'
            aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_KEYPOS] := 0
         ELSE
            aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_KEYPOS] := nCurrKeyNo - nTopKeyNo + 1
         ENDIF
         aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_RECORD] := nRecNo
         dbCargo(aScope)
      ENDIF
      nRecCount := aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_KEYCOUNT]
      RETURN aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_KEYPOS]
   ENDIF
   dbCargo(aScope)

RETURN -1

* -----------------

FUNCTION DC_keycount()

   LOCAL nRecNo, nRecords, cIndexKey, nLastRec, ;
      cRdd, aScope, nRecCount, nTopKeyNo, nBottomKeyNo

   LOCAL nSaveRec, nBottomKey, nTopKey, nKeyCount

   LOCAL aScopeArray := DC_SetScopeArray()
   IF Valtype(aScopeArray) = 'A'
     RETURN Len(aScopeArray)
   ENDIF

   IF Upper(_SetRdd())='PGDBE'
     RETURN -1
   ENDIF

   IF Empty(Alias())
     RETURN 0
   ELSEIF Left(DbInfo(DBO_FILENAME),8)=='<CURSOR>'
     RETURN RecCount()
   ENDIF

   IF !DC_ScopeExpress()
      nSaveRec := RecNo()
      _dbGoBottom()
      IF Eof()
         _dbGoTo(nSaveRec)
         RETURN 0
      ENDIF
      nBottomKey := OrdKeyNo()
      _dbGoTop()
      nTopKey := OrdKeyNo()
      IF nTopKey == NIL .OR. nBottomKey == NIL  // bug in ADSDBE when index is empty
        RETURN 0
      ENDIF
      nKeyCount := nBottomKey - nTopKey + 1
      _dbGoTo(nSaveRec)
      RETURN nKeyCount
   ENDIF

   IF Empty(Alias()) .OR. !slKeyEnable
      RETURN -1
   ENDIF

   cRdd := _SetRdd()
   nRecCount := RecCount()
   nRecNo := RecNo()
   cIndexKey := IndexKey(0)
   IF EMPTY(cIndexKey)
      RETURN nRecCount
   ENDIF

   IF cRdd == 'ADSDBE' .AND. DC_ScopeAds()
      nRecCount := AX_KeyCount()
      RETURN nRecCount
   ENDIF

   aScope := DC_DbCargo()
   IF Valtype(aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_TOP])='U' .OR. ;
         Valtype(aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_BOTTOM])='U'
      _dbGoBottom()
      IF Eof()
         nLastRec := 0
      ELSE
         nLastRec := DC_KeyNo()
      ENDIF
      GO nRecNo
      IF Valtype(nLastRec) = 'N'
         RETURN nLastRec
      ENDIF
      RETURN nRecCount
   ENDIF

   IF aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_GOODCOUNT] .AND. ;
         aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_RECCOUNT] == nRecCount
      RETURN aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_KEYCOUNT]
   ENDIF

   aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_RECCOUNT] := nRecCount
   nSaveRec := RecNo()
   DC_DbGoTop()
   nTopKeyNo := DC_KeyNo()
   DC_DbGoBottom()
   nBottomKeyNo := DC_KeyNo()
   IF Eof()
      nRecords := 0
   ELSE
      nRecords := nBottomKeyNo - nTopKeyNo + 1
   ENDIF
   _dbGoTo(nSaveRec)
   aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_KEYCOUNT] := nRecords
   aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_GOODCOUNT] := .t.

   dbCargo(aScope)

RETURN nRecords

* ----------------

FUNCTION DC_KeyStat ( lEnable )

LOCAL lOldEnable := slKeyEnable
slKeyEnable := IIF(VALTYPE(lEnable)='L',lEnable, slKeyEnable)

RETURN lOldEnable

* ----------------

FUNCTION DC_DbCargo()

LOCAL aScope := dbCargo()
IF Valtype(aScope) # 'A'
   aScope := {,,,{},,{}}
ENDIF
IF Len(aScope[DCCARGO_ORDER_ARRAY]) < _IndexOrd()
   ASize(aScope[DCCARGO_ORDER_ARRAY],_IndexOrd())
ENDIF
IF Valtype(aScope[DCCARGO_ORDER_ARRAY, _IndexOrd()]) # 'A'
   aScope[DCCARGO_ORDER_ARRAY, _IndexOrd()] := ;
     {,,.f., .f., 0, 0, .f., 0, 0, 0, .f., .f.,,,,,,}
ENDIF

dbCargo(aScope)

RETURN aScope

* -----------------

STATIC FUNCTION _IndexOrd()

IF IndexOrd() = 0
  RETURN 99
ENDIF

RETURN IndexOrd()

* -----------------

FUNCTION DC_dbReCalc( lAll )

LOCAL nSaveOrd := IndexOrd(), i, aScope

lAll := IIF( Valtype(lAll)='L',lAll,.f. )
aScope := DC_DbCargo()
IF lAll
   FOR i := 1 TO 100
      OrdSetFocus(i)
      IF IndexOrd() # i
         EXIT
      ENDIF
      aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_GOODCOUNT] := .f.
      aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_GOODPOS] := .f.
   NEXT
ELSE
  aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_GOODCOUNT] := .f.
  aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_GOODPOS] := .f.
ENDIF
OrdSetFocus(nSaveOrd)
dbCargo(aScope)
RETURN nil

* -------------------

FUNCTION dc_scoperec ( xTop, xBottom, nTopRec, nBottomRec )

LOCAL nSaveRec, xRelValue, cIndexKey, cLastChar, lSoftSeek, lExact

lExact := Set(_SET_EXACT,.f.)
nSaveRec := RECNO()
lSoftSeek := SET( _SET_SOFTSEEK, .t. )
cIndexKey := &(INDEXKEY(0))
SEEK xTop
nTopRec := RECNO()
IF cIndexKey < xTop
  nSaveRec := nTopRec
ENDIF
xRelValue := xBottom
IF &(INDEXKEY(0)) <= xBottom
  DO CASE
    CASE VALTYPE(xRelValue)='C'
      IF !EMPTY(xRelValue)
        cLastChar := SUBSTR(xRelValue,LEN(xRelValue))
        SEEK SUBSTR(xRelValue,1,LEN(xRelValue)-1)+CHR(ASC(cLastChar)+1)
        SKIP -1
      ENDIF
    CASE VALTYPE(xRelValue)$'ND'
      SEEK xRelValue+1
      SKIP -1
  ENDCASE
ENDIF
IF &(INDEXKEY(0)) > xBottom
  GO BOTT
  SKIP
  nTopRec := RECNO()
  nSaveRec := nTopRec
ENDIF
SET( _SET_SOFTSEEK, lSoftSeek )
nBottomRec := RECNO()
GO nSaveRec
Set(_SET_EXACT,lExact)
RETURN nSaveRec

/* ----------------- */

FUNCTION dc_indexfilt ( nOrder )

LOCAL cOrdFor := ''

IF EMPTY(ALIAS()) .OR. ' ' + _SetRdd() + ' ' $ ' DBF SDF DELIM FXDBF '
  RETURN cOrdFor
ENDIF
IF Valtype(nOrder)$'CN'
  cOrdFor := OrdFor(nOrder)
ELSE
  cOrdFor := OrdFor()
ENDIF
IF Empty(cOrdFor)
  cOrdFor := ''
ENDIF
RETURN cOrdFor

/* ----------------- */

FUNCTION dc_indexkey ( nOrder )

IF EMPTY(ALIAS()) .OR. ' ' + _SetRdd() + ' ' $ ' DBF SDF DELIM FXDBF ' ;
                  .OR. INDEXORD()=0
  RETURN ''
ENDIF
nOrder := IIF(VALTYPE(nOrder)='N',nOrder, INDEXORD())
RETURN IndexKey( nOrder )

* ------------------

FUNCTION DC_KeyNo32k( a, b, nMode, lDescending )

LOCAL nDivisor, nKeyCount, nKeyNo

DEFAULT nMode := 0, ;
        lDescending := .f.

IF DC_SetScope(0) == nil
  RETURN DC_DbPosition(,lDescending)
ENDIF
nKeyCount := DC_KeyCount()
nDivisor := Int(nKeyCount/32000) + 1
IF nDivisor <= 1
  nKeyNo := DC_KeyNo( a, @b )
ENDIF
nKeyNo := Int(DC_KeyNo(a)/nDivisor)
IF lDescending
  nKeyNo := nKeyCount - nKeyNo
ENDIF

RETURN nKeyNo

* ------------------

FUNCTION DC_KeyCount32k()

LOCAL nDivisor, nKeyCount

IF DC_SetScope(0) == nil
  nKeyCount := 100
ELSE
  nKeyCount := DC_KeyCount()
  nDivisor := Int(nKeyCount/32000) + 1
  IF !(nDivisor <= 1)
    nKeyCount := Int(nKeyCount/nDivisor)
  ENDIF
ENDIF

RETURN nKeyCount

* ---------------------

FUNCTION DC_DbGoKeyNo32k( nPos, lDescending )

LOCAL cFilter := DbFilter()

DEFAULT lDescending := .f.

IF lDescending
  dbGoPosition( 100-nPos )
ELSE
  dbGoPosition( nPos )
ENDIF

IF DC_ScopeExpress()
  IF Set(_SET_DELETED)  .OR. !Empty(cFilter)
    DO WHILE (Deleted() .OR. !Empty(cFilter) .AND. &(cFilter)) .AND. !Eof()
      SKIP
    ENDDO
  ENDIF
ENDIF

RETURN nil

* ---------------------

FUNCTION DC_TestBof()

LOCAL nRecNo := RecNo(), nRecords, aRecords := DC_SetScopeArray()

IF !Empty(aRecords)
  IF Valtype(aRecords[1]) == "A"
     RETURN aRecords[1][1] == RecNo()
  ELSE
     RETURN aRecords[1] == RecNo()
  ENDIF
ENDIF
nRecords := DC_dbSkipper(-1)
IF nRecNo > RecCount()
  GO Bottom
  SKIP
ELSE
  GO nRecNo
ENDIF
IF nRecords = 0
  RETURN .t.
ENDIF
RETURN .f.

* ---------------------

FUNCTION DC_TestEof()

LOCAL nRecNo := RecNo(), nRecords, aRecords := DC_SetScopeArray()

IF !Empty(aRecords)
  IF Valtype(aRecords[1]) == "A"
    RETURN ATail(aRecords)[1] == RecNo()
  ELSE
    RETURN ATail(aRecords) == RecNo()
  ENDIF
ENDIF

nRecords := DC_dbSkipper(1)
IF nRecNo > RecCount()
  GO Bottom
  SKIP
ELSE
  GO nRecNo
ENDIF
IF nRecords = 0
  RETURN .t.
ENDIF
RETURN .f.

/* ---------------------- */

FUNCTION DC_SubIndex( cScopeDex, cIndex, cCondition, xScopeTop, xScopeBottom )

LOCAL bCondition

IF Valtype(xScopeTop)#'U' .AND. Valtype(xScopeBottom)#'U'
  DC_SetScope(0,xScopeTop)
  DC_SetScope(1,xScopeBottom)
  DC_DbGoTop()
ELSE
  xScopeBottom := DC_SetScope(1)
ENDIF
bCondition := &('{||'+cCondition+'}')

ordCondSet( cCondition, bCondition, nil, {|| &(cIndex) <= xScopeBottom} )

ordCreate((cScopeDex),, (cIndex), {|| &(cIndex)},.f.)

RETURN nil

* ----------------

FUNCTION DC_NextChar( cLastChar )

LOCAL  i, nChar

STATIC aChars := nil

IF Empty(aChars)
  aChars := Array(256)
  FOR i := 1 TO 256
    aChars[i] := Chr(i)
  NEXT
  ASort(aChars)
ENDIF

nChar := AScan(aChars,cLastChar)
IF nChar = 0
  RETURN Chr( Asc( cLastChar ) + 1 )
ENDIF

RETURN aChars[nChar+1]

* -----------------

FUNCTION DC_LastChar()

LOCAL  i

STATIC aChars  := nil

IF Empty(aChars)
  aChars := Array(256)
  FOR i := 1 TO 256
    aChars[i] := Chr(i)
  NEXT
  ASort(aChars)
ENDIF

RETURN aChars[256]

* --------------------------

FUNCTION DC_DbLocate( bFor, bWhile, nNext, nRecord, lRest )

LOCAL xScopeTop, xScopeBot, nCount := 0, aScope

xScopeTop := DC_SetScope(0)
xScopeBot := DC_SetScope(1)

IF xScopeTop == NIL .AND. xScopeBot == NIL
  RETURN DbLocate( bFor, bWhile, nNext, nRecord, lRest )
ENDIF

IF !Empty(nRecord)
  GO nRecord
  RETURN nil
ENDIF

IF Empty(nNext)
  DC_DbGoTop()
ENDIF

DEFAULT bFor := {||.t.}, ;
        bWhile := {||.t.}, ;
        lRest := .t., ;
        nNext := RecCount()

aScope := DC_DbCargo()
aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_LOCATEFOR] := bFor
aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_LOCATEWHILE] := bWhile
aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_LOCATEREST] := lRest
aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_LOCATENEXT] := nNext
dbCargo(aScope)

DO WHILE !DC_Eof() .AND. Eval(bWhile) .AND. nCount++ < nNext

  IF Eval(bFor)
    EXIT
  ENDIF
  DC_DbSkip(1)

ENDDO

RETURN !Eof()

* --------------------------

FUNCTION DC_DbContinue()

LOCAL xScopeTop, xScopeBot, nCount := 0, aScope, bFor, bWhile, nNext

xScopeTop := DC_SetScope(0)
xScopeBot := DC_SetScope(1)

IF xScopeTop == NIL .AND. xScopeBot == NIL
  RETURN DbContinue()
ENDIF

aScope := DC_DBCargo()
bFor   := aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_LOCATEFOR]
bWhile := aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_LOCATEWHILE]
nNext  := aScope[DCCARGO_ORDER_ARRAY, IndexOrd(),DCCARGO_ORDER_LOCATENEXT]

DO WHILE !DC_Eof() .AND. Eval(bWhile) .AND. nCount++ < nNext

  IF Eval(bFor)
    EXIT
  ENDIF
  DC_DbSkip(1)

ENDDO

RETURN !Eof()

* --------------------

FUNCTION DC_DbGoPosition( nPos, lDescending )

LOCAL cFilter := DbFilter(), nTopKeyNo, nBottomKeyNo, nBottomRec, nRecCount, ;
      nSkip, xScopeTop, xScopeBot, nSaveRec, aScopeArray, nPointer

IF Empty(Alias()) .OR. RecCount() = 0 .OR. Upper(_SetRdd())='PGDBE'
  RETURN 0
ENDIF

DEFAULT lDescending := .f.

aScopeArray := DC_SetScopeArray()
IF Valtype(aScopeArray) = 'A' .AND. Len(aScopeArray) > 0
  nPointer := Int( nPos *.01 * Len(aScopeArray) )
  IF nPointer <= 0
    nPointer := 1
  ELSEIF nPointer >= Len(aScopeArray)
    nPointer := Len(aScopeArray)
  ENDIF
  IF Valtype(aScopeArray[nPointer]) = 'A'
    _dbGoTo(aScopeArray[nPointer,1])
  ELSE
    _dbGoTo(aScopeArray[nPointer])
  ENDIF
  DC_SetScopeArrayPointer(nPointer)
  RETURN nil
ENDIF

IF DC_ScopeExpress() .AND. IndexOrd() > 0 .AND. ;
    (xScopeTop := DC_SetScope(0)) # nil .AND. ;
    (xScopeBot := DC_SetScope(1)) # nil

  DC_DbGoBottom()
  nBottomRec := RecNo()
  nBottomKeyNo := OrdKeyNo()
  DC_DbGoTop()
  nTopKeyNo := OrdKeyNo()
  nRecCount := nBottomKeyNo - nTopKeyNo + 1
  IF lDescending
    _dbGoTo(nBottomRec)
    IF nPos > 1
      nSkip :=  -1 * (nPos/100) * nRecCount
    ELSE
      nSkip := 0
    ENDIF
  ELSE
    IF nPos > 1
      nSkip := (nPos/100) * nRecCount
    ELSE
      DC_DbGoTop()
      nSkip := 0
    ENDIF
  ENDIF

  _dbSkip(nSkip)

  IF Valtype(xScopeTop)#'U' .AND. _ScopeKey( xScopeTop ) < xScopeTop
    DC_DbGoTop()
  ELSEIF Valtype(xScopeBot)#'U' .AND. _ScopeKey( xScopeBot ) > xScopeBot
    DC_DbGoBottom()
  ENDIF

  IF Set(_SET_DELETED)  .OR. !Empty(cFilter)
    nSaveRec := RecNo()
    _dbSkip(-1)
    IF nSaveRec # RecNo() .OR. ( Bof() .AND. nPos > 0 )
      _dbSkip()
    ENDIF
  ENDIF

ELSE

  IF lDescending
    dbGoPosition( 100-nPos )
  ELSE
    IF nPos == 1
      dbGoTop()
    ELSE
      dbGoPosition( nPos )
    ENDIF
  ENDIF

ENDIF
RETURN nil

* -----------------

FUNCTION DC_ScopeExpress( lExpress )

STATIC slScopeExpress := nil
LOCAL lOldScope

IF slScopeExpress == NIL
  slScopeExpress := Val(Version(3)) < 261  // Xbase++ 1.6 or earlier
ENDIF

lOldScope := slScopeExpress
IF Valtype(lExpress) = 'L'
  slScopeExpress := lExpress
ENDIF
RETURN lOldScope

* -----------------

FUNCTION DC_ScopeAds( lAds )

STATIC slScopeAds := .T.
LOCAL lOldScope

IF slScopeAds == NIL
  slScopeAds := Val(Version(3)) < 261  // Xbase++ 1.6 or earlier
ENDIF

lOldScope := slScopeAds
IF Valtype(lAds) = 'L'
  slScopeAds := lAds
ENDIF
RETURN lOldScope

* -----------------

FUNCTION DC_dbSkipUnique( n )

RETURN dbSkipUnique( n )

* ------------------

STATIC FUNCTION _Reopen()

LOCAL cOrder      := OrdSetFocus()                 // Current selected order
LOCAL nRecno      := Recno()                       // Current record
LOCAL lDescend    := DbDescend()                   // Descending ?
LOCAL aScope      := {}
LOCAL cFilter     := DbFilter()                    // Filter condition
LOCAL bFilter     := "{||" + DbFilter() + "}"
LOCAL i           := 0
LOCAL cDataFile   := DbInfo(DBO_FILENAME)
LOCAL cIndexFile  := _IndexFileName()
LOCAL cDbeName    := DbInfo(DBO_DBENAME)
LOCAL cAlias      := Alias()

For i := 1 To OrdCount()
  Aadd( aScope, { DC_SetScope(0), DC_SetScope(1) } )
Next i
DC_DbCloseArea()

Sleep(10)

USE (cDataFile) VIA (cDbeName) ALIAS (cAlias)
IF !Empty(cIndexFile) .AND. cDbeName # 'ADSDBE'
  SET INDEX TO (cIndexFile)
ENDIF

For i := 1 To OrdCount()
  if i <= Len(aScope)
    if !Empty(aScope[i,1])
      DC_SetScope(0,aScope[i,1])
    endif
    if !Empty(aScope[i,2])
      DC_SetScope(1,aScope[i,2])
    endif
  endif
next i
OrdSetFocus(cOrder)
if !Empty(cFilter)
  DbSetFilter(&bFilter,cFilter)
endif
DbSetDescend(lDescend)
DbGoto(nRecno)

Return .T.

* --------------

STATIC FUNCTION _IndexFileName()

LOCAL cIndexName := '', cPath, nOrder

nOrder := IndexOrd()
cIndexName := OrdBagName( nOrder )
cPath := DC_Path(DbInfo(DBO_FILENAME))

IF !Empty(cIndexName) .AND. !Empty(cPath) .AND. Empty(DC_Path(cIndexName))
  cIndexName := cPath + cIndexName
ENDIF

RETURN cIndexName

* ---------------

STATIC FUNCTION _DbSkip( n )

LOCAL bError, lRetry := .T., x

RETURN dbSkip( n )

return x

* ---------------

STATIC FUNCTION _DbGoBottom()

LOCAL bError, lRetry := .T., x, nSeconds := Seconds()

RETURN dbGoBottom()

* ---------------

STATIC FUNCTION _DbGoTop()

LOCAL bError, lRetry := .T., x, nSeconds := Seconds()

RETURN DbGoTop()

* ---------------

STATIC FUNCTION _DbSeek(a,b,c,d)

LOCAL bError, lRetry := .T., x, nSeconds := Seconds()

RETURN DbSeek(a,b,c,d)

* ---------------

STATIC FUNCTION _DbSkipper( nWantSkip, lUnique )

LOCAL nDidSkip := 0

IF PCount() < 2
  lUnique := .F.
ENDIF

IF LastRec() == 0

ELSEIF nWantSkip == 0

   DbSkip(0)

ELSEIF nWantSkip > 0 .AND. !Eof()

  * Skip down *
  DO WHILE nDidSkip < nWantSkip
    IF lUnique
      DbSkipUnique(1)
      IF Eof()
        DbSkipUnique(-1)
        EXIT
      ENDIF
    ELSE
      DbSkip(1)
      IF Eof()
        DbSkip(-1)
        EXIT
      ENDIF
    ENDIF
     nDidSkip++
  ENDDO

ELSEIF nWantSkip < 0

  * Skip up *
  DO WHILE nDidSkip > nWantSkip
    IF lUnique
      DbSkipUnique(-1)
      IF Bof()
        EXIT
      ENDIF
    ELSE
      DbSkip(-1)
      IF Bof()
        EXIT
      ENDIF
    ENDIF
    nDidSkip --
  ENDDO

ENDIF

RETURN  nDidSkip

* ---------------

STATIC FUNCTION dbSkipUnique( n )

LOCAL xValue, cLastChar, cSeek, xNewValue

DEFAULT n := 1

IF _SetRdd() == 'ADSDBE'
  RETURN AX_SkipUnique( n )
ELSE
  IF n > 0
    xValue := &(IndexKey(0))
    cLastChar := SubStr(xValue,LEN(xValue))
    cSeek := SubStr(xValue,1,LEN(xValue)-1)+Chr(Asc(cLastChar)+1)
    dbSeek(cSeek,.t.)
  ELSE
    xValue := &(IndexKey(0))
    dbSkip(-1)
    xNewValue := &(IndexKey(0))
    IF xNewValue == xValue .AND. !Bof()
      dbSeek(xNewValue)
      dbSkip(-1)
    ENDIF
  ENDIF
ENDIF

RETURN nil

* ---------------

STATIC FUNCTION _DbGoto(n)

LOCAL bError, lRetry := .T., x, nSeconds := Seconds()

RETURN DbGoto(n)

/*
DO WHILE lRetry .AND. Seconds() - nSeconds < 5
  bError := ErrorBlock({|e|Break(e)})
  BEGIN SEQUENCE
  x := DbGoto(n)
  lRetry := .F.  // No error
  RECOVER
  ErrorBlock(bError)
  _Reopen()
  END SEQUENCE
  ErrorBlock(bError)
enddo

return x
*/

* ----------------

FUNCTION DC_DbGoTo( nRecNo, xDataSource )

LOCAL cDataType := Valtype(xDataSource), aScopeArray, nPointer

IF xDataSource == NIL
  aScopeArray := DC_SetScopeArray()
  IF !Empty(aScopeArray)
    nPointer := AScan( aScopeArray, nRecNo )
    IF nPointer > 0
      DC_SetScopeArrayPointer(nPointer)
    ENDIF
  ENDIF
  _dbGoTo(nRecNo)
ELSEIF cDataType == 'C'  // It's an alias
  aScopeArray := (xDataSource)->(DC_SetScopeArray())
  IF !Empty(aScopeArray)
    nPointer := AScan( aScopeArray, nRecNo )
    IF nPointer > 0
      (xDataSource)->(DC_SetScopeArrayPointer(nPointer))
    ENDIF
  ENDIF
ELSEIF cDataType == 'N'  // It's an ADS SQL cursor
  RETURN AdsGoToRecord( xDataSource, nRecNo )
ELSEIF cDataType == 'O'  // It's an SQLexpress cursor
  RETURN xDataSource:goTo(nRecNo)
ENDIF

RETURN nil

* ----------------

FUNCTION DC_DbCloseAll()

LOCAL xValue, bError := ErrorBlock({||TrapError()})
LOCAL aRel[0], i, j

BEGIN SEQUENCE

WorkSpaceEval( {|a|a:=DbRList(),IIF(!Empty(a),AAdd(aRel,{Select(),a}),nil)})

FOR i := 1 TO Len(aRel)
  FOR j := 1 TO Len(aRel[i,2])
    (aRel[i,1])->(dbClearRelation())
  NEXT
NEXT

xValue := dbCloseAll()

END SEQUENCE
ErrorBlock(bError)

RETURN xValue

* ----------------

FUNCTION DC_DbCloseArea()

LOCAL xValue, bError := ErrorBlock({||TrapError()})
LOCAL aRel[0], cAlias, i, j

BEGIN SEQUENCE

cAlias := '_' + Alias()

WorkSpaceEval( {|a|a:=DbRList(),IIF(!Empty(a),AAdd(aRel,{Select(),a}),nil)})

FOR i := 1 TO Len(aRel)
  FOR j := 1 TO Len(aRel[i,2])
    IF cAlias $ aRel[i,2,j]
      (aRel[i,1])->(dbClearRelation())
    ENDIF
  NEXT
NEXT

xValue := dbCloseArea()

END SEQUENCE
ErrorBlock(bError)

RETURN xValue


* ----------------

STATIC FUNCTION TrapError
BREAK
RETURN nil

* ----------------

FUNCTION DC_RecNo( xDataSource )

LOCAL nRecNo, cDataType := Valtype(xDataSource)
IF xDataSource == NIL
  RETURN RecNo()
ELSEIF cDataType == 'C' // it's an alias
  RETURN (xDataSource)->(RecNo())
ELSEIF cDataType == 'O' // it's an SQLexpress cursor
  RETURN xDataSource:recNo()
ELSEIF cDataType == 'N' // it's an ADS SQL cursor
  nRecNo := 0
  AdsGetRecordNum(xDataSource,ADS_IGNOREFILTERS,@nRecNo)
  RETURN nRecNo
ENDIF

RETURN Nil

* --------------------

FUNCTION DC_FieldName( nFieldPos, xDataSource )

LOCAL cFieldName := '', nLength, cDataType := Valtype(xDataSource)

IF xDataSource == NIL
  cFieldName := FieldName(nFieldPos)
ELSEIF cDataType == 'C' // It's an alias
  cFieldName := (xDataSource)->(FieldName(nFieldPos))
ELSEIF cDataType == 'O' // It's an SQLexpress cursor
  cFieldName := xDataSource:fieldName(nFieldPos)
ELSEIF cDataType == 'N' // It's an ADS SQL cursor
  cFieldName := Space(20)
  nLength := 20
  AdsGetFieldName( xDataSource, nFieldPos, @cFieldName, @nLength )
  cFieldName := Trim(cFieldName)
ENDIF

RETURN cFieldName

* -----------------

FUNCTION DC_FCount( xDataSource )

LOCAL nNumFields := 0, cDataType := Valtype(xDataSource)

IF xDataSource == NIL
  nNumFields := FCount()
ELSEIF cDataType == 'C' // It's an alias
  nNumFields := (xDataSource)->(FCount())
ELSEIF cDataType == 'O' // It's an SQLexpress cursor
  nNumFields := xDataSource:fCount()
ELSEIF cDataType == 'N' // It's an ADS SQL cursor
  AdsGetNumFields( xDataSource, @nNumFields )
ENDIF

RETURN nNumFields

* ----------------

FUNCTION DC_DbCommit( xDataSource )

IF Empty(xDataSource)
  dbCommit()
ELSEIF Valtype(xDataSource) == 'C'  // It's an alias
  (xDataSource)->(dbCommit())
ELSEIF Valtype(xDataSource) == 'N'  // It's an ADS SQL cursor
  // Commit not available
ELSEIF Valtype(xDataSource) == 'O'  // It's an SQLexpress cursor
  xDataSource:commit()
ENDIF

RETURN nil

* ----------------

FUNCTION dc_dbsel ( cAlias )

LOCAL i

IF Valtype(cAlias) == 'C'

  cAlias := IIF(Valtype(cAlias)='C',UPPER(cAlias),'')
  IF cAlias=='0'
    FOR i := 253 TO 1 STEP -1
      IF Empty(Alias(i))
        SELE (i)
        RETURN .t.
      ENDIF
    NEXT
    RETURN .f.
  ENDIF
  cAlias := IIF(Valtype(cAlias)='C',cAlias,'')
  IF SELECT(cAlias)>0 .AND. !(':'$cAlias)
    SELE SELECT(cAlias)
    RETURN .t.
  ENDIF

ENDIF

RETURN .f.

* ----------------

FUNCTION DC_OrdSetFocus( xOrder, xDataSource, cSortName, lDescend )

LOCAL cOldOrder := '', cDataType := Valtype(xDataSource), bSort, ;
      xCargo, nField, lOldDescend, bOldSort

DEFAULT cSortName := '', ;
        lDescend := .F.

IF xDataSource == NIL

  cOldOrder := OrdSetFocus(xOrder)

ELSEIF cDataType == 'C' // It's an alias

  cOldOrder := (xDataSource)->(OrdSetFocus(xOrder))

ELSEIF cDataType == 'N' // It's an ADS SQL cursor

  cOldOrder := 'Unknown'

ELSEIF cDataType == 'O' // It's an SQLexpress cursor

  IF Valtype(xOrder) == 'B'
    bSort := xOrder
  ELSE
    IF Valtype(xOrder) == 'C'
      nField := xDataSource:fieldPos(xOrder)
    ELSEIF Valtype(xOrder) == 'N'
      nField := xOrder
    ENDIF

    IF Valtype(nField) == 'N' .AND. nField > 0
      IF Empty(cSortName)
        cSortName := DC_FieldName(nField,xDataSource)
      ENDIF
      IF lDescend
        bSort := ;
          {|x,y|IIF(Valtype(x[nField])='C', ;
                Upper(x[nField]) < Upper(y[nField]), x[nField] < y[nField])}
      ELSE
        bSort := ;
          {|x,y|IIF(Valtype(x[nField])='C', ;
                Upper(x[nField]) > Upper(y[nField]), x[nField] > y[nField])}
      ENDIF
    ENDIF
  ENDIF

  IF Valtype(bSort) == 'B'
    xDataSource:sort(bSort)
  ENDIF

  IF DC_IsSQLCargo( xDataSource, @xCargo )
    cOldOrder := xCargo[DCSQL_CARGO_SORTNAME]
    lOldDescend := xCargo[DCSQL_CARGO_SORTDESCEND]
    bOldSort := xCargo[DCSQL_CARGO_SORTBLOCK]
    IF Valtype(bSort) == 'B'
      xCargo[DCSQL_CARGO_SORTNAME] := cSortName
      xCargo[DCSQL_CARGO_SORTDESCEND] := lDescend
      xCargo[DCSQL_CARGO_SORTBLOCK] := bSort
    ENDIF
    cSortName := cOldOrder
    xOrder := bOldSort
    lDescend := lOldDescend
  ENDIF

ENDIF

RETURN cOldOrder

* ----------------

FUNCTION DC_IsSQLCargo( xDataSource, xCargo )

xCargo := xDataSource:cargo

IF xDataSource:cargo == NIL
  xDataSource:cargo := DCSQL_CARGO_INIT
ENDIF

xCargo := xDataSource:cargo

RETURN Valtype(xCargo) == 'A' .AND. ;
       Len(xCargo) == DCSQL_CARGO_LEN .AND. ;
       Valtype(xCargo[DCSQL_CARGO_NAME]) == 'C' .AND. ;
       xCargo[DCSQL_CARGO_NAME] == 'eXpress++'

* -----------------
